-- # import prelude
-- # import nat
-- # import eq
-- # import order
-- # import vec

cumSum (ℓ : ℕ) : (i : ℕ) -> i ≤ ℓ -> Vec ℓ ℕ -> ℕ
cumSum i le = sum ∘ take i le

prop_cumSum_replicate (ℓ, i : ℕ)
  :  (n : ℕ) -> (le : i ≤ ℓ)
  -> cumSum i le (replicate n) ≡ i * n
prop_cumSum_replicate n le =
  cong sum (prop_take_replicate le)
    `trans`
  prop_sum_replicate _ n

infixl 6 ⊖

(⊖) (ℓ : ℕ) : Vec ℓ ℕ -> ℕ -> Vec ℓ ℕ
[]        ⊖ n = []
(x :: xs) ⊖ n = x ∸ n :: xs ⊖ (n ∸ x)

prop_sub_zero (ℓ : ℕ)
  : (xs : Vec ℓ ℕ) -> xs ⊖ 0 ≡ xs
prop_sub_zero []        = refl
prop_sub_zero (x :: xs) = cong ((::) x) $ prop_sub_zero xs

prop_sub_zero'
  : (ℓ : ℕ) -> (xs : Vec ℓ ℕ) -> xs ⊖ 0 == xs
prop_sub_zero' _ _ = toPropEq (prop_sub_zero _)

rewrite prop_sub_zero'

prop_sub_sub_plus (ℓ : ℕ)
  : (xs : Vec ℓ ℕ) -> (n₁, n₂ : ℕ) -> xs ⊖ n₁ ⊖ n₂ ≡ xs ⊖ (n₁ + n₂)
prop_sub_sub_plus []        _  _  = refl
prop_sub_sub_plus (x :: xs) n₁ n₂ =
  congBin (::)
    (subtractLinear `trans` cong ((∸) _) addCommutative)
    (prop_sub_sub_plus xs (n₁ ∸ x) (n₂ ∸ (x ∸ n₁))
       `trans`
     cong ((⊖) xs) prop_sub_swap_sub_sub
    )

prop_sum_sub (ℓ : ℕ)
  : (xs : Vec ℓ ℕ) -> (m : ℕ) -> sum (xs ⊖ m) ≡ sum xs ∸ m
prop_sum_sub []        m = refl
prop_sum_sub (x :: xs) m =
 cong ((+) (x ∸ m)) (prop_sum_sub xs (m ∸ x))
   `trans`
 prop_sub_swap_sub_sub

prop_sub_take (ℓ, i : ℕ)
  :  (n : ℕ) -> (le : i ≤ ℓ) -> (xs : Vec ℓ ℕ)
  -> take i le (xs ⊖ n) ≡ take i le xs ⊖ n
prop_sub_take _ leZ      _        = refl
prop_sub_take _ (leS le) (_ :: _) =
  cong ((::) _) (prop_sub_take _ le _)

prop_cumSum_sub (ℓ, i : ℕ)
  :  (n : ℕ) -> (le : i ≤ ℓ) -> (Cs : Vec ℓ ℕ)
  -> cumSum i le (Cs ⊖ n) ≡ cumSum i le Cs ∸ n
prop_cumSum_sub _ _ _ =
  cong sum (prop_sub_take _ _ _) `trans` prop_sum_sub _ _

prop_sub_plus (ℓ : ℕ)
  : (xs : Vec ℓ ℕ) -> (n : ℕ) -> toHead ((+) n) xs ⊖ n ≡ xs
prop_sub_plus []        _ = refl
prop_sub_plus (x :: xs) n =
  congBin (::)
    subtractPlusInverses'
    (congBin (⊖) refl subtractSelf'
       `trans`
     prop_sub_zero xs
    )
