------------------------------------------------------------------------
-- Example in which all steps are paid using credit
------------------------------------------------------------------------

module OperationalSemantics.Example where

open import Kind
open import TypeSystem
open import Substitution
open VarSubst
open import Value
open import OperationalSemantics.Binding
open Heap↦
open import OperationalSemantics.Thunked
open import MainResults

open import Relation.Binary.PropositionalEquality using (_≡_; ≡-refl)
open import Data.Nat using (ℕ; zero; suc; _<_; z≤n; s≤s)

Γ₁ : Ctxt thunked
Γ₁ = ε ▻ Nat

Σ₁ : Heap Γ₁
Σ₁ = ∅ʰ ▷ʰ ↦ⁿ_ {n = suc zero} ((λ return (var vz)) · z)

Γ₂ : Ctxt thunked
Γ₂ = ε ▻ Nat ▻ Nat

Σ₂ : Heap Γ₂
Σ₂ = ∅ʰ ▷ʰ ↦ z ▷ʰ ↦ z

τ : Ty thunked
τ = Nat

e : Γ₁ ⊢ τ
e = var vz

v : Γ₂ ⊢⇓ τ
v = z⇓

n : ℕ
n = suc zero

ρ : Γ₁ ⇒ Γ₂
ρ = wk ↑

d : Σ₁ ∣ e ⇊ ρ ⋉ Σ₂ ∣ v √ n
d = eval-vz (eval-· eval-λ (eval-·-λ (eval-return (eval-vz eval-z))))

prop₁ : time τ ≡ zero
prop₁ = ≡-refl

prop₂ : time τ < n
prop₂ = s≤s z≤n
